# Development Environment 

![sandbox](https://uptime.monitoring.iuk.hdm-stuttgart.de/api/badge/1/status)

## Introduction
use cases, limitations + t&c

## Getting Started

Within the sandbox, the different disciplines inside the IKID project can provide tasks to be worked on by the respective student groups. Both text-based tasks and programmatic tasks can be provided and processed. For example, Markdown files can be created for editing textual tasks. These files can be converted from the source form (unformatted) to the target form (formatted) using a simple syntax. 
Currently, it is planned for the technical lectures that the students get first in touch with the programming language Python. Therefore, the Sandbox platform was created, in which experiments with Python can be carried out. But if needed, it is possible to add more supported languages in the future. 

[Sandbox](https://sandbox.iuk.hdm-stuttgart.de/)
(only accessible from the HdM-Network)


1. **Sign in**, use your **HdM Credentials**
2. Select the image you want to start (two options)
   1. **Datascience environment**
   2. **GPU environment** (choose only if you realy need the graphic card, otherwise you steal resources from those who need them)
3. Create or upload a .ipynb file to start with 
   1. . **create a empty .ipynb file:**
    ![sandbox launcher](res/sandbox_launcher.png "Sandbox Launcher")
   2. **upload a existing .ipynb file:**
![sandbox upload file](res/sandbox_upload_file_selector.png "Sandbox upload file")
4. **open** the file from the filebrowser & start working!
![sandbox .ipynb file](res/sandbox_ipynb_example.png "Sandbox Notebook"). 
5. **After you finished your work dont forget to shutdown your server!** Therfore you should shutdown your server to release server resources. **Select File, Hub Control Panel**
![file menue](res/sandbox_file_menu.png "File menue")
7. Select **Stop Server**
![stop server](res/sandbox_stop_server.png "Stop Server")
1. Select the arrow in the upper right corner to **Logout** 
![logout](res/sandbox_logout.png)



## Technical Overview

Which python packages are installed, How can I install a python package? 
### Environments

#### Datascience environment
* Available Data Science image is based on [Official Data Science Image](https://hub.docker.com/r/jupyter/datascience-notebook/tags/) 
  * most common data analysis library's included for Julia, Python, R 

#### GPU environment
* Available GPU image is based on [Official GPU Image](https://hub.docker.com/r/cschranz/gpu-jupyter) 
  * support added for the NVIDIA GPU A100 calculations based on python most common GPU-able libraries Tensorflow, PyTorch and Keras.  


### Resources


### Limitations